﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Reflection;

namespace WpfApplication15
{
    public class ControlMenuItem : MenuItem
    {
        public ControlMenuItem()
        {
            Assembly assembly = Assembly.GetAssembly(typeof(Control));
            Type[] arrType = assembly.GetTypes();

            SortedList<string, MenuItem> sortList = new SortedList<string, MenuItem>();

            this.Header = "Control";
            this.Tag = typeof(Control);
            sortList.Add("Control", this);

            foreach (var type in arrType)
            {
                if (type.IsPublic && type.IsSubclassOf(typeof(Control)))
                {
                    MenuItem item = new MenuItem()
                                    {
                                        Header = type.Name,
                                        Tag = type
                                    };
                    
                    sortList.Add(type.Name, item);
                }
            }

            foreach (var kvp in sortList)
            {
                if (kvp.Key != "Control")
                {
                    string strParent = ((Type)kvp.Value.Tag).BaseType.Name;
                    MenuItem itemParent = sortList[strParent];
                    itemParent.Items.Add(kvp.Value);
                }
            }

            foreach (var kvp in sortList)
            {
                Type type2 = (Type)kvp.Value.Tag;
                if (type2.IsAbstract && kvp.Value.Items.Count == 0)
                    kvp.Value.IsEnabled = false;

                if (type2.IsAbstract && kvp.Value.Items.Count > 0)
                {
                    MenuItem item = new MenuItem()
                    {
                        Header = kvp.Value.Header as string,
                        Tag = type2
                    };

                    kvp.Value.Items.Insert(0, item);
                }
            }
        }
    }
}