﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Reflection;
using System.Xml;
using System.Windows.Markup;

namespace WpfApplication15
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        Control ctrl;

        public Window1()
        {
            InitializeComponent();
        }

        private void ControlMenuItem_Click(object sender, RoutedEventArgs e)
        {
            for (int i = 0; i < grid.Children.Count; i++)
            {
                if (Grid.GetRow(grid.Children[i]) == 0)
                {
                    grid.Children.Remove(grid.Children[i]);
                    break;
                }
            }

            txtbox.Text = "";

            MenuItem item = e.Source as MenuItem;
            Type type = (Type)item.Tag;

            ConstructorInfo info = type.GetConstructor(System.Type.EmptyTypes);

            try
            {
                ctrl = (Control)info.Invoke(null);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, Title);
                return;
            }

            try
            {
                grid.Children.Add(ctrl);
            }
            catch
            {
                if (ctrl is Window)
                    (ctrl as Window).Show();
                else
                    return;
            }

            Title = Title + "- " + type.Name;
        }

        private void MenuItem_SubmenuOpened(object sender, RoutedEventArgs e)
        {
            itemTemplate.IsEnabled = ctrl != null;
            itemItemsPanel.IsEnabled = ctrl != null && ctrl is ItemsControl;
        }

        private void itemTemplate_Click(object sender, RoutedEventArgs e)
        {
            if (ctrl != null)
                Dump(ctrl.Template);
        }

        private void itemItemsPanel_Click(object sender, RoutedEventArgs e)
        {
            if (ctrl != null && ctrl is ItemsControl)
                Dump((ctrl as ItemsControl).ItemsPanel);
        }

        void Dump(FrameworkTemplate template)
        {
            if (template != null)
            {
                XmlWriterSettings setting = new XmlWriterSettings()
                {
                    Indent = true,
                    NewLineChars = new string(' ', 4),
                    NewLineOnAttributes = true
                };

                StringBuilder strBuild = new StringBuilder();
                XmlWriter writer = XmlWriter.Create(strBuild, setting);

                try
                {
                    XamlWriter.Save(template, writer);
                    txtbox.Text = strBuild.ToString();
                }
                catch (Exception ex)
                {
                    txtbox.Text = ex.Message;
                }
            }
            else
            {
                txtbox.Text = "no Template";
            }
        }
    }
}
